*AJAE revision;
*Normalize by sum of budget shares;
*Theoretical restrictions imposed;
*Caluate AIDS Elasticities and Simulate Tax Scenarios Using Stata Estimates for current budget-weighted DM Model (ie FMDM);

libname home "/vol1/project/0213096.NHLBI_price/ny/ajae/demand/impr/normalize/r";
libname sasdata "/vol1/project/0213096.NHLBI_price/ny/ajae/compile/normalize";
libname top "/vol1/project/0213096.NHLBI_price/ny/ajae/demand/top";

*import the xport data;
libname xp1 xport "/vol1/project/0213096.NHLBI_price/ny/ajae/demand/xport/normalize/b6.xpt";
libname xp2 xport "/vol1/project/0213096.NHLBI_price/ny/ajae/demand/xport/normalize/cov6.xpt";

%include '/vol1/project/0213096.NHLBI_price/ny/ajae/macro/normalize/rand.sas';
%include '/vol1/project/0213096.NHLBI_price/ny/ajae/macro/normalize/dalist.sas';
%include '/vol1/project/0213096.NHLBI_price/ny/ajae/macro/normalize/dalist2.sas';
%include '/vol1/project/0213096.NHLBI_price/ny/ajae/macro/normalize/calist.sas';
%include '/vol1/project/0213096.NHLBI_price/ny/ajae/macro/normalize/calist2.sas'; 
%include '/vol1/project/0213096.NHLBI_price/ny/ajae/macro/normalize/mat_cz.sas';
%include '/vol1/project/0213096.NHLBI_price/ny/ajae/macro/normalize/e_cz_r.sas';

%let nsm = 500;     *# of random draws for standard errors;
%let nda = %sysfunc(countw(%dalist));   %put &nda;
%let nda2 = %sysfunc(countw(%dalist2)); %put &nda2;
%let nca = %sysfunc(countw(%calist));   %put &nca;
%let nca2 = %sysfunc(countw(%calist2)); %put &nca2;

proc sql;
select max(MID) into: NM from sasdata.spacedata;
select max(PID) into: NP from sasdata.spacedata;
%put there are &NM markets;
%put there are &NP brands;     

data parm; set xp1.b6; run;
data cov; set xp2.cov6; run;

data aid; set sasdata.spacedata;
if mktID = 2  then mkt2 = 1;  else mkt2 = 0;
if mktID = 7  then mkt7 = 1;  else mkt7 = 0;
if mktID = 32 then mkt32 = 1; else mkt32 = 0;
if mktID = 49 then mkt49 = 1; else mkt49 = 0;
if qtr <14 then yr07 = 1; else yr07 = 0;
if qtr > 13 and qtr < 27 then yr08 = 1; else yr08 = 0;
if qtr > 26 and qtr < 40 then yr09 = 1; else yr09 = 0;
if qtr > 39 and qtr < 53 then yr10 = 1; else yr10 = 0;
if qtr > 52 and qtr < 66 then yr11 = 1; else yr11 = 0;
if qw = 1  then qw1  = 1; else qw1  = 0;
if qw = 2  then qw2  = 1; else qw2  = 0;
if qw = 3  then qw3  = 1; else qw3  = 0;
if qw = 4  then qw4  = 1; else qw4  = 0;
if qw = 5  then qw5  = 1; else qw5  = 0;
if qw = 6  then qw6  = 1; else qw6  = 0;
if qw = 7  then qw7  = 1; else qw7  = 0;
if qw = 8  then qw8  = 1; else qw8  = 0;
if qw = 9  then qw9  = 1; else qw9  = 0;
if qw = 10 then qw10 = 1; else qw10 = 0;
if qw = 11 then qw11 = 1; else qw11 = 0;
if qw = 12 then qw12 = 1; else qw12 = 0;
if qw = 13 then qw13 = 1; else qw13 = 0;
y = hhinc/13/2.5;   
lnp_oth = (log(cpi)-(pcx/y)*stonep)/(1-pcx/y); 
run;

proc sort data = aid;
by MID PID;
run;

%e_cz_r;               

data home.allmkte_r;
set allmkte;
run;

data home.allmktq_r;
set allmktq;
run;

quit;





