*AJAE revision;
*_ga means Greens and Alston 1990 elasticities for conventional DM or quasi-FMDM;
*match product attributes with rivals for unweighted and base-share weighted DM;
%macro mat_ga;

data own; *data set with renamed own price and attributes;
set temp;
if TPID ne &n then delete;
%if (&nda+&nda2) gt 0 %then %do k = 1 %to (&nda+&nda2);
 R%scan((%dalist %dalist2),&k) = %scan((%dalist %dalist2),&k); keep R%scan((%dalist %dalist2),&k);
%end;
%if (&nca+&nca2) gt 0 %then %do k = 1 %to (&nca+&nca2);
 R%scan((%calist %calist2),&k) = %scan((%calist %calist2),&k); keep R%scan((%calist %calist2),&k);
%end;
Rw0 = w0;
RPID = PID;
keep MID RPID Rw0;
run;

*data set with own and rival product prices and attributes;
data all; set temp;
*assign indicators for which products are to be taxed;
if calorie > 10 and cat10 ne 4 then tid1 = 1; else tid1 = 0;   *>10 kcal/serving taxable excluding 100% juices;
run;

data all;
merge own all;
by MID;
*Discrete measures;
%if &nda ne 0 %then %do k = 1 %to &nda;
  if R%scan(%dalist,&k) = %scan(%dalist,&k) and R%scan(%dalist,&k) ne " " and %scan(%dalist,&k) ne " "
   then do;
     if &mv = 1 then D%scan(%dalist,&k) = 1; 
     if &mv = 2 then D%scan(%dalist,&k) = w0;
   end;
   else D%scan(%dalist,&k) = 0;
%end;
%if &nda2 ne 0 %then %do k = 1 %to &nda2;
  if R%scan(%dalist2,&k) ne scan(%dalist2,&k) 
   then do;
     if &mv = 1 then D%scan(%dalist2,&k) = 1; 
     if &mv = 2 then D%scan(%dalist2,&k) = w0; 
   end;
   else D%scan(%dalist2,&k) = 0;
%end;
*one-way Continuous measures;
%if &nca ne 0 %then %do k = 1 %to &nca;
  if R%scan(%calist,&k) ne 888 and %scan(%calist,&k) ne 888 then do;
   C%scan(%calist,&k) = 1/(1+2*abs(R%scan(%calist,&k)-%scan(%calist,&k)));
  end;
  else do;
   C%scan(%calist,&k) = 0;
  end;
%end;   
*two-way Continuous measures;
%if &nca2 ne 0 %then %do;
  denom = 1;
  %do k = 1 %to &nca2;
   denom = denom + 2*abs(R%scan(%calist2,&k)-%scan(%calist2,&k));
  %end;
  C%scan(%calist2,1) = 1/denom;
%end;
run;

data cross;
set all;
if RPID = PID then delete;
run;

proc summary data = cross;
var %if (&nda+&nda2) gt 0 %then %do k = 1 %to (&nda+&nda2); D%scan((%dalist %dalist2),&k) %end;;
by MID;
output out = basew sum = %if (&nda+&nda2) gt 0 %then %do k = 1 %to (&nda+&nda2); BD%scan((%dalist %dalist2),&k) %end;;
run;

data all;
merge all basew;
by MID;

*weights for cross price terms discrete attributes;
%if (&nda+&nda2) gt 0 %then %do i = 1 %to (&nda+&nda2);
 ws&i = 0; 
%end;  

*weights for cross price terms continuous attributes;
%if (&nca+&dnca2) gt 0 %then %do i = 1 %to (&nca+&dnca2);
 wc&i = 0; 
%end;

if RPID ne PID then do;
 %do l = 1 %to (&nda+&nda2);
   if &mv = 1 then ws&l = D%scan((%dalist %dalist2),&l)/(BD%scan((%dalist %dalist2),&l)+1);
   if &mv = 2 then ws&l = D%scan((%dalist %dalist2),&l)/(BD%scan((%dalist %dalist2),&l)+Rw0); 
 %end;
 %if (&nca+&dnca2) gt 0 %then %do l = 1 %to (&nca+&dnca2);
    wc&i = C%scan((%calist %calist2),&l);
 %end;
end;
run;

%if (&nda+&nda2) gt 0 %then %do i = 1 %to (&nda+&nda2);
  proc transpose data = all out = ws&i; var ws&i; run;  
  data ws&i._onemkt; set ws&i._onemkt ws&i; drop _NAME_; run;
%end;

%if (&nca+&dnca2) gt 0 %then %do i = 1 %to (&nca+&dnca2);
  proc transpose data = all out = wc&i; var wc&i; run;  
  data wc&i._onemkt; set wc&i._onemkt wc&i; drop _NAME_; run;
%end;

%mend;
