*Draw random parameters from distribution of the parameter estimates;
*For calculating t-values for elasticities;
%Macro rand;
proc iml;

use top.parm_top; read all into parm1 [colname=cname1];

use top.cov_top; read all into cov1;

use parm; read all into parm2 [colname=cname2];

use cov; read all into cov2;

call randseed(123);

sim_parm = (parm1||parm2)//randnormal(&nsm,parm1||parm2,block(cov1,cov2));

sim_parm1 = sim_parm[,1:ncol(parm1)];

sim_parm2 = sim_parm[,ncol(parm1)+1:ncol(sim_parm)];

create sim_parm1 from sim_parm1 [colname=cname1];
append from sim_parm1;

create sim_parm2 from sim_parm2 [colname=cname2];
append from sim_parm2;

quit;

%mend rand;
