capture log close
clear                            
set more off                 
set mem 100m      
set matsize 5000           
log using rivers.log, replace

/*STATA codes*/
/*perform the Rivers and Vuong (2002) test of non-nested models (conventional, quasi-, and FM DM)*/


mata

mata matuse xi_m2, replace

mata matuse xi_m4, replace

mata matuse xi_m6, replace

mata matuse rt_m2, replace

mata matuse rt_m4, replace

mata matuse rt_m6, replace

q = rows(mzz_m2)

t = rows(e_m2)

gt_m2 = cross(z_m2,e_m2)/t

gt_m4 = cross(z_m4,e_m4)/t

gt_m6 = cross(z_m6,e_m6)/t

Qt_m2 = gt_m2'*invsym(mzz_m2)*gt_m2

Qt_m4 = gt_m4'*invsym(mzz_m4)*gt_m4

Qt_m6 = gt_m6'*invsym(mzz_m6)*gt_m6


sig2_2v4=4*(gt_m2'*invsym(mzz_m2)*(cross(z_m2:*e_m2,z_m2:*e_m2)/t)*invsym(mzz_m2)*gt_m2 + gt_m4'*invsym(mzz_m4)
            *(cross(z_m4:*e_m4,z_m4:*e_m4)/t)*invsym(mzz_m4)*gt_m4 - 2*gt_m2'*invsym(mzz_m2)
            *(cross(z_m2:*e_m2,z_m4:*e_m4)/t)*invsym(mzz_m4)*gt_m4)

rv_2v4 = sqrt(t)*(Qt_m2-Qt_m4)/sqrt(sig2_2v4)


sig2_2v6=4*(gt_m2'*invsym(mzz_m2)*(cross(z_m2:*e_m2,z_m2:*e_m2)/t)*invsym(mzz_m2)*gt_m2 + gt_m6'*invsym(mzz_m6)
            *(cross(z_m6:*e_m6,z_m6:*e_m6)/t)*invsym(mzz_m6)*gt_m6 - 2*gt_m2'*invsym(mzz_m2)
            *(cross(z_m2:*e_m2,z_m6:*e_m6)/t)*invsym(mzz_m6)*gt_m6)

rv_2v6 = sqrt(t)*(Qt_m2-Qt_m6)/sqrt(sig2_2v6)


sig2_4v6=4*(gt_m4'*invsym(mzz_m4)*(cross(z_m4:*e_m4,z_m4:*e_m4)/t)*invsym(mzz_m4)*gt_m4 + gt_m6'*invsym(mzz_m6)
            *(cross(z_m6:*e_m6,z_m6:*e_m6)/t)*invsym(mzz_m6)*gt_m6 - 2*gt_m4'*invsym(mzz_m4)
            *(cross(z_m4:*e_m4,z_m6:*e_m6)/t)*invsym(mzz_m6)*gt_m6)

rv_4v6 = sqrt(t)*(Qt_m4-Qt_m6)/sqrt(sig2_4v6)


rv_2v4

rv_2v6

rv_4v6




end

log close

exit







   



